<?php
/**
 * ajax playsmsusernotifier File Doc Comment
 *
 * @author   App World sp. z o.o.
 * @copyright 2018 App World sp. z o.o.
 * @license  http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * @category playsmsusernotifier
 * @package  playsmsusernotifier
 *
 */

require_once(dirname(__FILE__) . '../../../config/config.inc.php');
require_once(dirname(__FILE__) . '../../../init.php');

function getAvailableOrderStatuses()
{

    $context = Context::getContext();
    $id_lang = $context->cart->id_lang;
    $sql     = new DbQuery();
    $sql->select('os.id_order_state, osl.name');
    $sql->from('order_state', 'os');
    $sql->leftJoin(
        'order_state_lang',
        'osl',
        'os.id_order_state = osl.id_order_state AND osl.id_lang =' . (int)$id_lang
    );
    $getAvailableOrderStatuses = Db::getInstance()->executeS($sql);

    $orderStatuses = array();

    foreach ($getAvailableOrderStatuses as $available_order_status_id) {
        $orderStatuses[$available_order_status_id['id_order_state']] = $available_order_status_id['name'];
    }

    return $orderStatuses;
}

switch (Tools::getValue('method')) {
    case 'addEventAjax':
        $eventName              = playSMS_sanitize(Tools::getValue('eventName'));
        $eventMessage           = playSMS_sanitize(Tools::getValue('eventsMessage'));
        $eventConvertCharacters = playSMS_sanitize(Tools::getValue('playSMS-changePolishLettersCheckbox'));
        $eventSenderField       = playSMS_sanitize(Tools::getValue('senderField'));
        $eventAssociatedHook    = playSMS_sanitize(Tools::getValue('associatedHook'));
        $eventActionType        = playSMS_sanitize(Tools::getValue('associatedHookName'));

        if (! empty($eventMessage)
            && ! empty($eventName)
            && ! empty($eventAssociatedHook)
            && ! empty($eventSenderField)) {
            $response = Db::getInstance()->insert('playsms_events', array(
                'name'               => pSQL($eventName),
                'associated_hook'    => pSQL($eventAssociatedHook),
                'sms_message'        => pSQL($eventMessage),
                'action_type'        => pSQL($eventActionType),
                'convert_characters' => (int)$eventConvertCharacters,
                'message_header'     => pSQL($eventSenderField)
            ));
        } else {
            $response = 0;
        }

        echo $response;

        break;

    case 'loadEvents':
        $sql = new DbQuery();
        $sql->select('*');
        $sql->from('playsms_events');
        $getEvents = Db::getInstance()->executeS($sql);

        if (isset($getEvents) && ! empty($getEvents)) {
            foreach ($getEvents as $event) {
                echo '<tr>';
                echo '<td class="eventsRowName">' . (string)$event["name"] . '</td>';
                echo '<td class="eventsRowMessage">' . (string)$event["sms_message"] . '</td>';
                echo '<td class="eventsRowActionType">' . (string)$event["action_type"] . '</td>';
                echo '<td class="eventsRowSenderField">' . (string)$event["message_header"] . '</td>';
                echo '<td class="eventsRowActions"><button id="editEvent-' . (int)$event["id"] . '" 
                class="playSMS-editEvent btn btn-info" 
                style="margin-right: 10px;">Edytuj</button>
                <button id="removeEvent-' . (int)$event["id"] . '" 
                class="playSMS-removeEvent btn btn-danger">Usuń</button> </td>';
                echo '</tr>';
            }
        } else {
            echo 'Brak eventów.';
        }

        break;

    case 'removeEvent':
        $eventID         = (int)Tools::getValue('eventID');
        $deleteRowResult = Db::getInstance()->delete('playsms_events', 'id=' . $eventID);
        if ($deleteRowResult === true) {
            echo 1;
        }

        break;

    case 'editEvent':
        $eventID = (int)Tools::getValue('eventID');
        $sql     = 'SELECT * FROM ' . _DB_PREFIX_ . 'playsms_events WHERE id =' . $eventID;
        $row     = Db::getInstance()->getRow($sql);

        echo json_encode($row);

        break;

    case 'updateEditedEvent':
        $eventName               = playSMS_sanitize(Tools::getValue('eventName'));
        $eventMessage            = playSMS_sanitize(Tools::getValue('eventsMessage'));
        $eventConvertCharacters  = (int)Tools::getValue('playSMS-changePolishLettersCheckbox');
        $eventSenderField        = playSMS_sanitize(Tools::getValue('senderField'));
        $eventAssociatedHook     = playSMS_sanitize(Tools::getValue('associatedHook'));
        $eventAssociatedHookName = playSMS_sanitize(Tools::getValue('associatedHookName'));
        $eventID                 = (int)Tools::getValue('eventID');

        if (! isset($eventAssociatedHook) && ! isset($eventAssociatedHookName)) {
            $eventAssociatedHook     = "Brak";
            $eventAssociatedHookName = "Brak";
        }

        $sql = 'UPDATE ' . _DB_PREFIX_ . 'playsms_events SET name = "' .
               pSQL($eventName) . '", sms_message = "' .
               pSQL($eventMessage) . '", convert_characters ="' .
               $eventConvertCharacters . '", message_header="' .
               pSQL($eventSenderField) . '", associated_hook="' .
               pSQL($eventAssociatedHook) . '", action_type="' .
               pSQL($eventAssociatedHookName) . '" WHERE id = ' . $eventID;

        $result = Db::getInstance()->execute($sql);

        if ($result === true) {
            echo 1;
        } else {
            echo 0;
        }

        break;

    default:
        exit;
}

function playSMS_sanitize($data)
{
    $data = trim($data);
    $data = Tools::stripslashes($data);
    $data = htmlspecialchars($data);

    return $data;
}

exit;
