var subdir = "";
/**
 * @author App World sp. z o.o.
 * @license    http://www.gnu.org/copyleft/gpl.html GNU General Public license
 */
$(document).ready(function () {

    $(window).on("load", loadEvents);

    $('#playSMS-addEventForm').on('submit', function (event) {

        event.preventDefault();
        var baseDir = window.location.protocol + "//" + window.location.host + "/" + subdir;
        var associatedHook = $('#playsms-addEventActionTypeContainer select').find(":selected").val();
        var associatedHookName = $('#playsms-addEventActionTypeContainer select').find(":selected").text();
        var senderField = $('#playsms-addEventSenderFieldsContainer select').find(":selected").val();
        var eventsMessage = $('#playSMS-eventMessage').val();

        if (jQuery('#playSMS-changePolishLettersCheckbox').is(":checked")) {
            var convertCharacters = 1;
        } else {
            var convertCharacters = 0;
        }

        $.ajax({

            type: 'POST',
            url: baseDir + 'modules/playsmsusernotifier/ajax.php',
            data: 'method=addEventAjax&eventName=' + $('#eventsName').val() + '&eventsMessage=' + eventsMessage + '&playSMS-changePolishLettersCheckbox=' + convertCharacters + '&senderField=' + senderField + '&associatedHook=' + associatedHook + '&associatedHookName=' + associatedHookName,
            dataType: 'json',

            beforeSend: function () {

                $('#playSMS_actionConfirmationModal').modal('show');
                $('#playSMS-modalConfirmationMessage').text('Trwa dodawanie eventu...');
            },

            success: function (json) {

                $('.playSMS-loaderAjax').hide();

                if (json == 1) {
                    $("#playSMS-modalConfirmationButtonAfterAjax").show();
                    $('#playSMS-modalConfirmationMessage').html('Event dodany prawidłowo!');
                    loadEvents();
                } else {
                    $('#playSMS-modalConfirmationMessage').html('Wystąpił błąd podczas dodawania eventu.');
                }
            }
        });
    });

    $(document).on('submit', '#playSMS-editEventForm', function (event) {

        event.preventDefault();

        var baseDir = window.location.protocol + "//" + window.location.host + "/" + subdir;
        var eventID = $('#playSMS-editEventID').val();
        var eventsMessage = $('#playSMS-editEventMessage').val();
        var senderField = $('#playSMS-editSenderFieldsContainer select').find(":selected").val();
        var associatedHookName = $('#playSMS-editEventsActionTypeContainer select').find(":selected").text();
        var associatedHook = $('#playSMS-editEventsActionTypeContainer select').find(":selected").val();


        if (jQuery('#playSMS-changePolishLettersCheckboxEdit').is(":checked")) {
            var convertCharacters = 1;
        } else {
            var convertCharacters = 0;
        }

        $.ajax({
            type: 'POST',
            url: baseDir + 'modules/playsmsusernotifier/ajax.php',
            data: 'method=updateEditedEvent&eventName=' + $('#playSMS-editEventName').val() + '&eventsMessage=' + eventsMessage + '&playSMS-changePolishLettersCheckbox=' + convertCharacters + '&senderField=' + senderField + '&associatedHook=' + associatedHook + '&eventID=' + eventID + '&associatedHookName=' + associatedHookName,
            dataType: 'json',
            beforeSend: function () {

                $('#playSMS-editEventModal').modal('hide');
                $('#playSMS_actionConfirmationModal').modal('show');
                $('#playSMS-modalConfirmationMessage').text('Trwa edytowanie eventu...');
            },
            success: function (json) {

                $('.playSMS-loaderAjax').hide();
                $("#playSMS-modalConfirmationButtonAfterAjax").show();
                if (json == 1) {

                    $('#playSMS-modalConfirmationMessage').html('Edycja eventu zakończona pomyślnie.');

                    loadEvents();
                } else {
                    $('#playSMS-modalConfirmationMessage').html('Wystąpił błąd podczas edycji eventu.');
                }
            }
        });
    });

    function changeSpecialCharactersToNormalCharacters(textareaValue, elementID) {
        var polishSpecialChars = {};
        polishSpecialChars['ą'] = 'a';
        polishSpecialChars['Ą'] = 'A';
        polishSpecialChars['ć'] = 'c';
        polishSpecialChars['Ć'] = 'C';
        polishSpecialChars['ę'] = 'e';
        polishSpecialChars['Ę'] = 'E';
        polishSpecialChars['ł'] = 'l';
        polishSpecialChars['Ł'] = 'L';
        polishSpecialChars['ń'] = 'n';
        polishSpecialChars['Ń'] = 'N';
        polishSpecialChars['ó'] = 'o';
        polishSpecialChars['Ó'] = 'O';
        polishSpecialChars['ś'] = 's';
        polishSpecialChars['Ś'] = 'S';
        polishSpecialChars['ź'] = 'z';
        polishSpecialChars['Ź'] = 'Z';
        polishSpecialChars['ż'] = 'z';
        polishSpecialChars['Ż'] = 'Z';
        var textAreaNewValue = '';

        if (/^[a-zA-Z0-9- {}]*$/.test(textareaValue) === false) {
            jQuery.each(polishSpecialChars, function (key, value) {
                if (elementID.indexOf('edit') >= 0) {
                    textAreaNewValue = jQuery('#playSMS-editEventMessage').val();
                    if (textAreaNewValue.indexOf(key) >= 0) {
                        var regex = new RegExp(key, 'igm');
                        var newMessage = textAreaNewValue.replace(regex, value);
                        jQuery('#playSMS-editEventMessage').val(newMessage);
                    }
                } else {
                    textAreaNewValue = jQuery('#playSMS-eventMessage').val();
                    if (textAreaNewValue.indexOf(key) >= 0) {
                        var regex = new RegExp(key, 'igm');
                        var newMessage = textAreaNewValue.replace(regex, value);
                        jQuery('#playSMS-eventMessage').val(newMessage);
                    }
                }
            });
        }
    }

    function loadEvents() {
        var baseDir = window.location.protocol + "//" + window.location.host + "/" + subdir;
        $.ajax({
            type: 'POST',
            url: baseDir + 'modules/playsmsusernotifier/ajax.php',
            data: 'method=loadEvents',
            beforeSend: function (xhr) {
                $('tbody').html('<div id="playSMS-loadingContainer">Ładowanie&#8230;</div>');
            },
            success: function (response) {
                $('tbody').html(response);
            }
        });
    }

    $(document).on('click', '.playSMS-editEvent', function () {

        var eventsRemoveButtonID = $(this).attr('id');
        var eventsIndexToGetID = eventsRemoveButtonID.lastIndexOf('-');
        var eventsID = eventsRemoveButtonID.substring(eventsIndexToGetID + 1);
        var baseDir = window.location.protocol + "//" + window.location.host + "/" + subdir;
        $('#playSMS-editEventID').val(eventsID);

        $.ajax({
            type: 'POST',
            url: baseDir + 'modules/playsmsusernotifier/ajax.php',
            data: 'method=editEvent&eventID=' + eventsID,
            datatype: 'json',

            beforeSend: function (xhr) {
                $('#playSMS-modalConfirmationMessage').html('Trwa ładowanie eventu...');
            },
            success: function (response) {

                var eventData = JSON.parse(response);
                var eventName = eventData['name'];
                var eventMessage = eventData['sms_message'];
                var eventHook = eventData['associated_hook'];
                var convertCharacters = eventData['convert_characters'];
                var messageHeader = eventData['message_header'];
                $('#playSMS-editEventName').val(eventName);
                $('#playSMS-editEventMessage').val(eventMessage);
                $("#playSMS-editEventsActionTypeContainer select").val(eventHook);

                if (convertCharacters == 1) {
                    $('#playSMS-changePolishLettersCheckboxEdit').prop('checked', true);
                } else {
                    $('#playSMS-changePolishLettersCheckboxEdit').prop('checked', false);
                }

                $('#playSMS-editSenderFieldsContainer select').val(messageHeader);

                $('#playSMS-editEventModal').modal('show');

            }
        });

    });

    $(document).on('click', '.playSMS-removeEvent', function () {

            var eventsRemoveButtonID = $(this).attr('id');
            var eventsIndexToGetID = eventsRemoveButtonID.lastIndexOf('-');
            var eventsID = eventsRemoveButtonID.substring(eventsIndexToGetID + 1);

            $('#playSMS_actionConfirmationModal').modal('show');
            $('.playSMS-loaderAjax').hide();
            $('#playSMS-modalConfirmationMessage').html('Czy na pewno chcesz usunąć dany event?');

            if (!$(".playSMS-removeButtons").length) {
                $("#playSMS-modalConfirmationButtonAfterAjax").hide();
                $(".modal-body").append('<div class="playSMS-removeButtons" style="display: flex; justify-content: center;"></div>')
                $(".playSMS-removeButtons").append('<button id="playSMS-dontRemoveEventAjaxButton" style="margin: 20px 20px 0 0;" type="button" class="btn btn-lg btn-default" data-dismiss="modal">Wróć</button>');
                $(".playSMS-removeButtons").append('<button id="playSMS-confirmRemoveEvent-' + eventsID + '" style="margin-top: 20px;" type="button" class="btn btn-lg btn-danger playSMS-removeEventAjaxButton" data-dismiss="modal">Usuń</button>');
            } else {
                (".playSMS-removeButtons").show();
            }

        }
    );

    $(document).on('click', '#playSMS-dontRemoveEventAjaxButton', function () {
        $('.playSMS-removeButtons').remove();
    });

    $(document).on('click', '.playSMS-removeEventAjaxButton', function () {

        $('.playSMS-removeButtons').remove();
        var baseDir = window.location.protocol + "//" + window.location.host + "/" + subdir;
        var buttonID = $(this).attr('id');
        var eventsIndexToGetID = buttonID.lastIndexOf('-');
        var eventID = buttonID.substring(eventsIndexToGetID + 1);

        $.ajax({
            type: 'POST',
            url: baseDir + 'modules/playsmsusernotifier/ajax.php',
            data: 'method=removeEvent&eventID=' + eventID,
            beforeSend: function (xhr) {
                $('#playSMS-modalConfirmationMessage').html('Trwa usuwanie eventu...');
            },
            success: function (response) {
                if (response == 1) {
                    $('#playSMS-modalConfirmationMessage').html('Event usunięty prawidłowo.');
                }
                loadEvents();
            }
        });

    });


    var text_max = 160;
    jQuery('#playSMS-countMessage').html("<p>Zostało " + text_max + " znaków</p>");


    jQuery('#playSMS-changePolishLettersCheckbox, #playSMS-changePolishLettersCheckboxEdit').change(function () {
        var eventMessageID, messageCounterID, textareaEventID;
        var getID = $(this).prop('id');

        if (getID.indexOf("Edit") >= 0) {
            eventMessageID = '#playSMS-editEventMessage';
            messageCounterID = '#playSMS-countMessageEdit';
        } else {
            eventMessageID = '#playSMS-eventMessage';
            messageCounterID = '#playSMS-countMessage';
        }
        var textAreaCount = jQuery(eventMessageID).val().length;
        var textAreaValue = jQuery(eventMessageID).val();
        var $remaining = jQuery(messageCounterID),
            $messages = $remaining.next();

        if (jQuery(this).is(':checked')) {
            changeSpecialCharactersToNormalCharacters(textAreaValue, eventMessageID);
            text_max = 160;
        } else {
            text_max = 70;
        }

        var chars = this.value.length,
            messages = Math.ceil(textAreaCount / text_max),
            remaining = messages * text_max - (textAreaCount % (messages * text_max) || messages * text_max);
        if (messages > 5) {
            $remaining.html("<p>Wykorzystano limit znaków.</p>");
        } else {
            $remaining.html("<p>Liczba wiadomości SMS: " + messages + "<br>Zostało " + remaining + " znaków</p>");
        }
        if (textAreaCount === 0 && messages === 0) {
            if (jQuery(this).is(':checked')) {
                $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 160 znaków</p>");
            } else {
                $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 70 znaków</p>");
            }
        }
    });

    jQuery('#playSMS-eventMessage, #playSMS-editEventMessage').keyup(function () {
        var getID = $(this).prop('id');
        var checkbox, messageCounter, eventMessageID;
        if (getID.indexOf("edit") >= 0) {
            checkbox = '#playSMS-changePolishLettersCheckboxEdit';
            messageCounter = '#playSMS-countMessageEdit';
            eventMessageID = '#playSMS-editEventMessage';
        } else {
            checkbox = '#playSMS-changePolishLettersCheckbox';
            messageCounter = '#playSMS-countMessage';
            eventMessageID = '#playSMS-eventMessage';
        }
        var messageWritten = jQuery(this).val();
        if (jQuery(checkbox).is(':checked')) {
            changeSpecialCharactersToNormalCharacters(messageWritten, eventMessageID);
        }

        var $remaining = jQuery(messageCounter),
            $messages = $remaining.next();
        var chars = this.value.length,
            messages = Math.ceil(chars / text_max),
            remaining = messages * text_max - (chars % (messages * text_max) || messages * text_max);

        if (messages > 5) {
            $remaining.html("<p>Wykorzystano limit znaków.</p>");
        } else {
            $remaining.html("<p>Liczba wiadomości SMS: " + messages + "<br>Zostało " + remaining + " znaków</p>");
        }

        if (chars === 0 && messages === 0) {

            $remaining.html("<p>Liczba wiadomości SMS: 1<br>Zostało 160 znaków</p>");
        }
    });
});

/**
 * Save caret position on loosing focus and add variable in message at the saved caret position
 */
var caretStart, caretEnd;

$(document).on('blur', '#playSMS-eventMessage, #playSMS-editEventMessage', function (e) {
    caretStart = this.selectionStart;
    caretEnd = this.selectionEnd;
});

$(document).on('click', '.playSMS-addVariableToMessage', function () {
    var textareaID;
    var parentID = $(this).parent().attr('id');
    if (parentID === 'playSMS-editEventButtonsContainer') {
        textareaID = '#playSMS-editEventMessage';
    } else if (parentID === 'playSMS-addEventButtonsContainer') {
        textareaID = '#playSMS-eventMessage';
    }

    $(textareaID).focus();
    var textToAdd = "{{" + $(this).val() + "}} ";
    var eventsTextareaMessage = $(textareaID);

    // set text area value to: text before caret + desired text + text after caret
    eventsTextareaMessage.val(eventsTextareaMessage.val().substring(0, caretStart)
        + textToAdd
        + eventsTextareaMessage.val().substring(caretEnd));

    // put caret at right position again
    eventsTextareaMessage.selectionStart = eventsTextareaMessage.selectionEnd = caretStart + textToAdd.length;
    jQuery(textareaID).keyup();
});

(function ($, undefined) {
    $.fn.getCursorPosition = function () {
        var el = $(this).get(0);
        var pos = 0;
        if ('selectionStart' in el) {
            pos = el.selectionStart;
        } else if ('selection' in document) {
            el.focus();
            var Sel = document.selection.createRange();
            var SelLength = document.selection.createRange().text.length;
            Sel.moveStart('character', -el.value.length);
            pos = Sel.text.length - SelLength;
        }
        return pos;
    }
})(jQuery);

/**
 *  Characters count section
 */

